/* Datei: union_bsp.c */
#include <stdio.h>
#include <math.h>       /* enthaelt die Wurzelfunktion sqrt() */ 

int main (void)
{
   int i;
   
   enum punktArt {KARTESISCH, RADIAL};                   /*(1)*/
   
   struct kartesischerPunkt                              /*(2)*/
   {                            
      double x, y;                             /* Koordinaten */
   } ;
   struct radialPunkt                                    /*(3)*/
   {                                  
      double radius;                    /* Radius ab Ursprung */
      double phi;                       /* Winkel in Grad     */
   };
   
   struct punkt 
   {                                                     /*(4)*/
      enum punktArt art; 
      union 
      {                                                  /*(5)*/
         struct kartesischerPunkt kPunkt;
         struct radialPunkt rPunkt;
      } u;
   };
   
   struct punkt pts[2];                                  /*(6)*/
   
   pts[0].art = KARTESISCH;                              /*(7)*/
   pts[0].u.kPunkt.x = 1.;
   pts[0].u.kPunkt.y = 1.;
   /* Unlogisch, aber moeglich: pts[0].u.rPunkt.phi = 45.;    */
   
   pts[1].art = RADIAL;
   pts[1].u.rPunkt.radius = sqrt (2.); /* sqrt() = Wurzel aus */
   pts[1].u.rPunkt.phi = 45.;
   
   for (i=0; i < sizeof pts / sizeof pts[0]; i++)        /*(8)*/
   {
      switch (pts[i].art)                                /*(9)*/
      {
      case KARTESISCH: printf ("(x,y)=(%f,%f)\n", 
            pts[i].u.kPunkt.x, pts[i].u.kPunkt.y); 
         break;
      case RADIAL: printf ("(r,phi)=(%f,%f)\n", 
            pts[i].u.rPunkt.radius, pts[i].u.rPunkt.phi); 
         break;
      }
   }
   return 0;
}

