/* Datei: laby.c */
#include <stdio.h>

enum {ZEILEN=3000, SPALTEN=6000}; /* Maxima */
char zellen[ZEILEN][SPALTEN] = {
	"#########################",
	"# #     # #             #",
	"# # ### # # # # #########",
	"#   # #   # # #     #   #",
	"# # # # ### # ##### # # #",
	"# #   #     #     #   # #",
	"# ############# ### ### #",
	"#       #     # #   # # #",
	"####### # ### # # ### # #",
	"#       #   # # #     # #",
	"# ### ##### # ####### ###",
	"#   #     # # #     #   #",
	"##### ### # # # ### ### #",
	"#     #   # # # # # #   #",
	"# ######### # # # # # # #",
	"#           # #   #   #Z#",
	"#########################" };

/* Moegliche Richtungen beim Suchen: */
enum richtungen {OST, SUED, WEST, NORD};

/* Wie verlief die Suche in einem Teilast?: */
enum suchErgebnis {MISSERFOLG, ERFOLG};

enum suchErgebnis suche (unsigned int zeile,  
                         unsigned int spalte) 
{  if (zellen [zeile][spalte] != 'Z') /* Ziel gefunden?   (1)*/
   {
      if (zellen [zeile][spalte] != ' ') /* nicht frei    (2)*/
      {
         return MISSERFOLG;
      }
      else                                                          
      {
         enum richtungen lfdRichtung;
         zellen [zeile][spalte] = '+';       /* Weg markieren  (3)*/
         /* In jede Richtung rekursiv eine neue Suche starten: (4)*/
         for (lfdRichtung=OST; lfdRichtung <= NORD; lfdRichtung++)
         {
            enum suchErgebnis retWert;
            switch (lfdRichtung)
            {
            case OST:  
               retWert = suche (zeile   , spalte + 1); break;
            case SUED: 
               retWert = suche (zeile + 1, spalte   ); break;
            case WEST: 
               retWert = suche (zeile   , spalte - 1); break;
            case NORD: 
               retWert = suche (zeile - 1, spalte   ); break;
            }
            if (retWert == ERFOLG) 
            {  /* Weitere Suche eruebrigt sich, Ziel gefunden. (5)*/
               return retWert;
            }
         }
         /* Ummarkieren, da Sackgasse (alle Wege erfolglos)    (6)*/
         zellen [zeile][spalte] = 'x'; 
         return MISSERFOLG;
      }
   }
   else
   {
      return ERFOLG;
   }
}

void printLabyrinth (unsigned int zeilen, 
                     unsigned int spalten)
{
   unsigned int zeile, spalte;
   for (zeile=0; zeile < zeilen; zeile++)
   {
      printf("\n");
      for (spalte=0; spalte < spalten; spalte++)
      {
         printf("%c", zellen [zeile][spalte]);
      }
   }
}

int main(void)
{
   if (suche(1,1) == ERFOLG)
   {
      printLabyrinth (17, 26);
   }
   return 0;
}

